// Author 		: F. de la Parra
// Date			: March, 2019

public class Controller extends Person implements Identifiable {
	
	private String location;
	private String shift;
	
	// Default constructor.
	public Controller() {
		super.setUniqueId(99999999);
		licenseType = "";
	}
	
	// Full parameter constructor.
	public Controller(int newId, String newLicenseType) {
		super.setUniqueId(newId);
		licenseType = newLicenseType;
	}
	
	// Accessor methods.
	
	public String getLicenseType() {
		return licenseType;
	}
	
	// Mutator methods.
	
	public void setLicenseType(String newLicenseType) {
		licenseType = newLicenseType;
	}
	
	// BEHAVIOUR METHODS
	
	// Basic methods.
	
	public String toString() {
		return "License type is " + licenseType;
	}
	
	// Application behaviour methods.

	// The 'Identifiable' interface makes the implementation of this method mandatory.	
	public void updateIdType(String pIdType) {
		try {
			// Convert 'string' pIdType to 'enumerated value' tempPIdType.
			personIdType tempPIdType = personIdType.valueOf(pIdType.toUpperCase());
			if (tempPIdType.equals(personIdType.ANONYMOUS))
				setUniqueId(99999999);
			else if (tempPIdType.equals(personIdType.IDENTIFIED)) {
				if (getUniqueId() == 99999999) {
					Object tempObject = new Object();
					setUniqueId(tempObject.hashCode());
				}
			}
		}
		catch(IllegalArgumentException e){
			System.out.println("\n'" + pIdType + "' is an invalid person id type!");
			System.out.println("Program aborted!");
			System.exit(0);
		}
	}
	
	// The 'Identifiable' interface makes the implementation of this method mandatory.
	public void displayInfo(int id) {
		System.out.println("Displaying info for " + id);
	}
}