// Author 		: F. de la Parra
// Date			: March, 2019
// Version      : 1.0

import java.util.Random;

public interface Identifiable {
	// Definitions of constants.
	
	// Enumerations.
	public static enum usageType {PASS, CASUAL};
	public static enum personIdType {ANONYMOUS, IDENTIFIED};
	public static enum licenseTypeItem {A, B, C, D, E, F, G};
	
	// Constant values.
	public static final double HST = 0.05;
	
	// Methods to write in each class implementing this interface.
	public void displayInfo(int uniqueId);
	
	public void updateIdType(String pIdType);
	
	// Note: In addition to abstract methods, the following can also be
	// included in interfaces:
	// 1) Default methods
	// 2) Static methods
	// 3) Private methods
	// 4) Private static methods
	
	// Object 'rGen' created with an anonymous class. It implements polymorphic
	// (overloaded) versions of a random number generator. It requires that 
	// 'Randomizer' interface be declared and accessible. 'Randomizer' must 
	//specify both versions of the 'next' method.
	
	Randomizer rGen = new Randomizer() {		// anonymous class
						private Random gen = new Random(System.currentTimeMillis());
						
						public int next() {
							return gen.nextInt();
						}
						
						public int next(int lowest, int highest) {
							return lowest + gen.nextInt(highest - lowest);
						}
					};
}