// Author 		: F. de la Parra
// Date			: March, 2018

public class Passenger extends Person implements Identifiable {

	private String usage;
	
	// Default constructor.
	public Passenger() {
		usage = "CASUAL";
	}
	
	// Full parameter constructor.
	public Passenger(int newId, String newIdType, String newUsage) {
		setUniqueId(newId);
		setIdType(newIdType.toUpperCase());
		usage = newUsage.toUpperCase();
	}
	
	// Accessor methods.
	
	public String getUsage() {
		return usage;
	}
	
	// Mutator methods.
	
	public void setUsage(String newUsage) {
		usage = newUsage;
	}
	
	// BEHAVIOUR METHODS
	
	// Basic methods.
	
	public String toString() {
		return "usage is " + usage;
	}
	
	// Application behaviour methods.

	// The 'Identifiable' interface makes the implementation of this method mandatory.
	public void updateIdType(String pIdType) {
		try {
			// Convert 'string' pIdType to 'enumerated value' tempPIdType.
			personIdType tempPIdType = personIdType.valueOf(pIdType.toUpperCase());

			if (tempPIdType.equals(personIdType.ANONYMOUS)) {
				super.setUniqueId(-1);
				super.setIdType(pIdType.toUpperCase());
			}
			else if (tempPIdType.equals(personIdType.IDENTIFIED)) {
				Object tempObject = new Object();
				super.setUniqueId(tempObject.hashCode());
			}
		}
		catch(IllegalArgumentException e){
			System.out.println("\n'" + pIdType + "' is an invalid person id type!");
			System.out.println("Program aborted!");
			System.exit(0);
		} 
	}
	
	// The 'Identifiable' interface makes the implementation of this method mandatory.
	public void displayInfo(int id) {
		System.out.println("Displaying info for " + id);
	}
}