// Author 		: F. de la Parra
// Date			: March, 2019

public class Taxi extends Vehicle implements Scheduled{
	private String bodyType; 
	private int passengers;
	private String territory;
	
	// Default constructor.
	public Taxi() {
		bodyType = "";
		passengers = 0;
		territory = "";
	}
	
	public Taxi(String type, int capacity, String area) {
		// At this point, for example, we can run the default constructor of
		// the 'Vehicle' base class to partially initialize a 'Taxi' object.
		super();
		
		bodyType = type;
		passengers = capacity;
		territory = area;
	}
	
	// Accessor methods
	
	public String getBodyType() {
		return bodyType;
	}
	
	public int getPassengers() {
		return passengers;
	}
	
	public String getTerritory() {
		return territory;
	}
	
	// Mutator methods
	
	public void setBodyType(String newBodyType) {
		bodyType = newBodyType;
	}
	
	public void setPassengers(int newPassengers) {
		passengers = newPassengers;
	}
	
	public void setTerritory(String newTerritory) {
		territory = newTerritory;
	}
	
	// BEHAVIOUR METHODS
	
	// Basic methods.
	
	public String toString() {
		return super.toString();
	}

	public String toString(String newBodyType) {
		if (bodyType == newBodyType)
			return "bodyType = " + bodyType + "\n" +
				   "passengers = " + passengers + "\n" +
				   "territory = " + territory;
		return "Unknown body type!";
	}
	
	// Application behaviour methods.
	
	public boolean addItem(int id, Vehicle schedItem) {
		System.out.println("Adding taxi " + id + " to scheduled items.");
		return true;
	}

	public boolean deleteItem(int id) {
		System.out.println("Deleting taxi " + id + " from scheduled items." + id);
		return true;
	}
}